#include <stdio.h>
#include <stdlib.h>
#include <sys/select.h>
#include <editline/readline.h>

static char *line;

static void rlhandler(char *text)
{
    line = text;
    rl_callback_handler_remove();
}

int main(void)
{
    int has_input = 0;
    fd_set selectset;
    struct timeval *timeoutp = NULL;
    char *not_done_reading = "";

    do {
        line = not_done_reading;
        FD_ZERO(&selectset);
        rl_callback_handler_install(">>> ", rlhandler);
        while (line == not_done_reading) {
            while (!has_input) {
                FD_SET(fileno(stdin), &selectset);
                has_input = select(fileno(stdin) + 1, &selectset,
                               NULL, NULL, timeoutp);
            }
            if (has_input > 0) {
                rl_callback_read_char();
            }
        }
        if (line) {
            printf("You typed: %s\n", line);
            add_history(line);
            free(line);
        }
    } while (line);

    return 0;
}
